# fastify-grpc-client

[![Package Version](https://img.shields.io/npm/v/fastify-grpc-client.svg)](https://npm.im/fastify-grpc-client)
[![Dependency Status](https://img.shields.io/david/nearform/fastify-grpc-client)](https://david-dm.org/nearform/fastify-grpc-client)
[![Build](https://github.com/nearform/fastify-grpc-client/workflows/CI/badge.svg)](https://github.com/nearform/fastify-grpc-client/actions?query=workflow%3ACI)

<!-- [![Code Coverage](https://img.shields.io/codecov/c/gh/nearform/-verify?token=d0ae1643f35c4c4f9714a357f796d05d)](https://codecov.io/gh/nearform/fastify-grpc-client) -->

GRPC client plugin for Fastify

## Install

Just run:

```bash
npm install fastify-grpc-client --save
```

## Test

Clone this repository, then do:

```
npm install
npm test
```

## Usage

Register as a plugin:

```
const grpcClient = require('fastify-grpc-client');
...
fastify.register(grpcClient, {
  protoFile: path.join(__dirname, 'your_proto_file.proto'),
  server: 'localhost',
  port: 50051,
  namespace: 'helloworld',
  service: 'NameOfService'
});
```

You can then use your gRPC services as follows:

```
fastify.get('/echo', function (request, reply) {
  const msg = request.query.msg;
  this.grpc.helloworld.invoke('Greet', {
    greeting: {
      first_name: msg,
      last_name: 'boh'
    }
  }, (err, response) => {
      return reply.send(response.result);
  })
})
```

Adding multiple clients is supported, each one will have its separate namespace.

## Contributing

See [CONTRIBUTING.md](./CONTRIBUTING.md)

## License

Copyright NearForm Ltd 2019. Licensed under the [Apache-2.0 license](http://www.apache.org/licenses/LICENSE-2.0).
